<template id="categories-stats">
  <div class="box box-warning">
    <div class="box-header with-border">
      <h3 class="box-title">Categories stats</h3>
      <div class="box-tools pull-right">
        <button
          v-show="!show_table"
          @click="showAndHideComponents(true,false,false)"
          type="button"
          class="btn show-table-btn"
        >
          <i class="fa fa-table"></i>
        </button>
        <button
          v-show="!show_pie_chart"
          @click="showAndHideComponents(false,true,false)"
          type="button"
          class="btn show-chart-btn"
        >
          <i class="fa fa-chart-pie"></i>
        </button>
        <button
          v-if="!show_bar_chart"
          @click="showAndHideComponents(false,false,true)"
          type="button"
          class="btn show-chart-btn"
        >
          <i class="fa fa-chart-bar"></i>
        </button>
      </div>
    </div>
      <div class="box-body">
      <div class="chart">
          <div class="card">
            <div class="card-body">
            <div class="chart">
              <DoughnutChart v-if="show_pie_chart" :chartData="chartData" :options="optionsPie"></DoughnutChart>
              <BarChart v-if="show_bar_chart" :chartData="chartData" :options="optionsBar"></BarChart>
            </div>
            <div v-if="show_table && tableStats" class="table-area">
              <table class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Category name</th>
                    <th>Amount, €</th>
                    <th>Percentage</th>
                  </tr>

                  <tr v-for="result in tableStats.data" :key="result.name">
                    <td>{{ result.name}}</td>
                    <td>{{ result.amount }} €</td>
                    <td>{{ result.percentage }}%</td>
                  </tr>
                </tbody>
              </table>

              </div>
              <div v-if="show_table" class="card-footer">
                <pagination
                  class="paginator"
                  :data="tableStats"
                  @pagination-change-page="getTableStats"
                ></pagination>
              </div>
            </div>
            </div>
      </div>
    </div>
  </div>
</template>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.13.0/moment.min.js"></script>
<script src="https://chartjs-plugin-datalabels.netlify.com/guide/positioning.html#clamping"></script>

<script>
import DoughnutChart from "./DoughnutChart.vue";
import BarChart from "./BarChart.vue";
import moment from "moment";

export default {
  props: ["date_interval", "stats", "interval"],

  components: {
    DoughnutChart,
    BarChart
  },
  data: function() {
    return {
      chartData: {},
      optionsPie: null,
      optionsBar: null,
      tableStats: {},
      show_table: false,
      show_bar_chart: false,
      show_pie_chart: true
    };
  },

  created: function() {
    this.setChartValues();
  },

  watch: {
    date_interval: function() {
      this.setChartValues();
      this.show_table = false;
    },

    stats: function() {
      this.setChartValues();
    }
  },

  methods: {
    showAndHideComponents(table, pie, bar) {
      if (table) {
        this.show_table = true;
        this.getTableStats();
      } else if (pie) {
        this.show_table = false;
        this.show_bar_chart = false;
        this.show_pie_chart = true;
      }

      if (bar) {
        this.show_table = false;
        this.show_bar_chart = true;
        this.show_pie_chart = false;
      }
    },

    getTableStats(page = 1) {
      let uri = "api/categories-stats/" + this.interval;

      axios
        .get(uri, {
          params: {
            page: page,
            paginate: 1
          }
        })
        .then(response => {
          this.tableStats = response.data.results;
        });
    },

    setChartValues: function() {
      let labels = this.stats.results.map(list => {
        return list.name;
      });

      let amounts = this.stats.results.map(list => {
        return list.amount;
      });

      let percentages = this.stats.results.map(list => {
        return list.percentage;
      });

      this.assignChartValues(labels, amounts, percentages);
    },

    assignChartValues: function(labels, amounts, percentages) {
      this.chartData = {
        labels: labels,
        datasets: [
          {
            label: "Transaction sum",
            backgroundColor: Fire.getRandomColorHex(labels.length),
            borderColor: Fire.getRandomColorHex(),
            fill: true,
            data: amounts,
            datalabels: {
              labels: {
                title: {
                  font: {
                    weight: "bold",
                    size: 15
                  }
                }
              }
            }
          }
        ]
      };

      this.optionsPie = {
        title: {
          display: false
        },
        tooltips: {
          callbacks: {
            label: function(tooltipItem, data) {
              return data["datasets"][0]["data"][tooltipItem["index"]] + " €";
            },

            title: function(tooltipItem, data) {
              return data["labels"][tooltipItem[0]["index"]];
            }
          },
          xPadding: 8,
          backgroundColor: "#FFF",
          titleFontSize: 18,
          titleFontColor: "#0066ff",
          bodyFontColor: "#000",
          bodyFontSize: 18,
          displayColors: false
        },

        plugins: {
          datalabels: {
            color: "white",
            display: false
          }
        },

        callbacks: {
          labelColor: function(tooltipItem, chart) {
            return {
              borderColor: "red",
              backgroundColor: "red"
            };
          },
          labelTextColor: function(tooltipItem, chart) {
            return "red";
          }
        }
      };

      this.optionsBar = Object.assign({}, this.optionsPie);

      this.optionsBar.scales = {
          yAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "Amount, €"
              },
              ticks: {
               beginAtZero: true
              } 
            }
          ],
          xAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "categories"
              }
            }
          ]
        },

      this.optionsBar.legend = {
        display: false
      };
    }
  }
};
</script>
